<?php
declare(strict_types=1);

namespace App\Model\Table;

use Cake\ORM\RulesChecker;
use Cake\ORM\Table;
use Cake\Validation\Validator;

/**
 * AvancesProyectos Model
 *
 * @property \App\Model\Table\SeguimientosProyectosTable&\Cake\ORM\Association\BelongsTo $SeguimientosProyectos
 */
class AvancesProyectosTable extends Table
{
    public function initialize(array $config): void
    {
        parent::initialize($config);

        $this->setTable('avances_proyectos');
        $this->setDisplayField('fecha_avance');
        $this->setPrimaryKey('id');

        $this->addBehavior('Timestamp');

        $this->belongsTo('SeguimientosProyectos', [
            'foreignKey' => 'seguimiento_proyecto_id',
            'joinType' => 'INNER',
        ]);
    }

    public function validationDefault(Validator $validator): Validator
    {
        $validator
            ->integer('seguimiento_proyecto_id')
            ->requirePresence('seguimiento_proyecto_id', 'create')
            ->notEmptyString('seguimiento_proyecto_id', 'El seguimiento de proyecto es requerido');

        $validator
            ->date('fecha_avance')
            ->requirePresence('fecha_avance', 'create')
            ->notEmptyDate('fecha_avance', 'La fecha del avance es requerida');

        $validator
            ->date('proximo_hito')
            ->allowEmptyDate('proximo_hito');

        $validator
            ->scalar('detalles_avance')
            ->allowEmptyString('detalles_avance');

        $validator
            ->scalar('modulos_completados')
            ->allowEmptyString('modulos_completados');

        $validator
            ->scalar('observaciones')
            ->allowEmptyString('observaciones');

        $validator
            ->scalar('estado_control')
            ->maxLength('estado_control', 1)
            ->allowEmptyString('estado_control');

        return $validator;
    }

    public function buildRules(RulesChecker $rules): RulesChecker
    {
        $rules->add($rules->existsIn(['seguimiento_proyecto_id'], 'SeguimientosProyectos'), ['errorField' => 'seguimiento_proyecto_id']);

        return $rules;
    }
}
